import { OverloadedArgs, MutableState, ExtractArgs, EventState, RefEvent } from './index.js';
export { DurableArgs, DurableFun, DurableState, EventArgs, EventFun, Fun, MutableArgs, Nested, NestedFun, durable, default as event, mutable, nested } from './index.js';

declare const useOnce: <T>(fun: () => T) => T;
declare const useMutable: <T extends object>(...args: OverloadedArgs<MutableState<T, ExtractArgs<T>>>) => MutableState<T, ExtractArgs<T>>;
declare const useEvent: <T extends object>(...args: OverloadedArgs<MutableState<T, ExtractArgs<T>>>) => EventState<object, unknown[]>;
declare const useRefEvent: <T extends object>(...args: OverloadedArgs<MutableState<T, ExtractArgs<T>>>) => RefEvent<T, unknown>;

export { EventState, ExtractArgs, MutableState, OverloadedArgs, RefEvent, useEvent as default, useEvent, useMutable, useOnce, useRefEvent };
